/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.0
 * @date    2020-10-13T20:44:00.711Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var r=function(t){return t&&t.Math==Math&&t},n=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof t&&t)||Function("return this")(),o=function(t){try{return!!t()}catch(t){return!0}},i=!o((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),a=function(t){return"object"==typeof t?null!==t:"function"==typeof t},u=n.document,c=a(u)&&a(u.createElement),f=function(t){return c?u.createElement(t):{}},s=!i&&!o((function(){return 7!=Object.defineProperty(f("div"),"a",{get:function(){return 7}}).a})),l=function(t){if(!a(t))throw TypeError(String(t)+" is not an object");return t},h=function(t,e){if(!a(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!a(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!a(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!a(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},v=Object.defineProperty,p={f:i?v:function(t,e,r){if(l(t),e=h(e,!0),l(r),s)try{return v(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},y=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d=i?function(t,e,r){return p.f(t,e,y(1,r))}:function(t,e,r){return t[e]=r,t},g=function(t,e,r,n){n&&n.enumerable?t[e]=r:d(t,e,r)},m=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:g(t,n,e[n],r);return t},b={},w={}.hasOwnProperty,O=function(t,e){return w.call(t,e)},x=0,k=Math.random(),S=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++x+k).toString(36)},j=!o((function(){return Object.isExtensible(Object.preventExtensions({}))})),A=e((function(t){var e=p.f,r=S("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},u=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!a(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!O(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!O(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return j&&u.REQUIRED&&o(t)&&!O(t,r)&&i(t),t}};b[r]=!0})),E={}.propertyIsEnumerable,_=Object.getOwnPropertyDescriptor,I={f:_&&!E.call({1:2},1)?function(t){var e=_(this,t);return!!e&&e.enumerable}:E},T={}.toString,P=function(t){return T.call(t).slice(8,-1)},D="".split,L=o((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==P(t)?D.call(t,""):Object(t)}:Object,M=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},C=function(t){return L(M(t))},F=Object.getOwnPropertyDescriptor,R={f:i?F:function(t,e){if(t=C(t),e=h(e,!0),s)try{return F(t,e)}catch(t){}if(O(t,e))return y(!I.f.call(t,e),t[e])}},N=/#|\.prototype\./,z=function(t,e){var r=U[G(t)];return r==V||r!=q&&("function"==typeof e?o(e):!!e)},G=z.normalize=function(t){return String(t).replace(N,".").toLowerCase()},U=z.data={},q=z.NATIVE="N",V=z.POLYFILL="P",W=z,J={},$=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,r){if($(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},K=R.f,Q=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},Y=function(t,e){var r,o,i,a,u,c,f,s,l=t.target,h=t.global,v=t.stat,p=t.proto,y=h?n:v?n[l]:(n[l]||{}).prototype,g=h?J:J[l]||(J[l]={}),m=g.prototype;for(i in e)r=!W(h?i:l+(v?".":"#")+i,t.forced)&&y&&O(y,i),u=g[i],r&&(c=t.noTargetGet?(s=K(y,i))&&s.value:y[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(f=t.bind&&r?B(a,n):t.wrap&&r?Q(a):p&&"function"==typeof a?B(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&d(f,"sham",!0),g[i]=f,p&&(O(J,o=l+"Prototype")||d(J,o,{}),J[o][i]=a,t.real&&m&&!m[i]&&d(m,i,a)))},H=n["__core-js_shared__"]||function(t,e){try{d(n,t,e)}catch(r){n[t]=e}return e}("__core-js_shared__",{}),X=e((function(t){(t.exports=function(t,e){return H[t]||(H[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Z=!!Object.getOwnPropertySymbols&&!o((function(){return!String(Symbol())})),tt=Z&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,et=X("wks"),rt=n.Symbol,nt=tt?rt:rt&&rt.withoutSetter||S,ot=function(t){return O(et,t)||(Z&&O(rt,t)?et[t]=rt[t]:et[t]=nt("Symbol."+t)),et[t]},it={},at=ot("iterator"),ut=Array.prototype,ct=function(t){return void 0!==t&&(it.Array===t||ut[at]===t)},ft=Math.ceil,st=Math.floor,lt=function(t){return isNaN(t=+t)?0:(t>0?st:ft)(t)},ht=Math.min,vt=function(t){return t>0?ht(lt(t),9007199254740991):0},pt={};pt[ot("toStringTag")]="z";var yt="[object z]"===String(pt),dt=ot("toStringTag"),gt="Arguments"==P(function(){return arguments}()),mt=yt?P:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),dt))?r:gt?P(e):"Object"==(n=P(e))&&"function"==typeof e.callee?"Arguments":n},bt=ot("iterator"),wt=function(t){if(null!=t)return t[bt]||t["@@iterator"]||it[mt(t)]},Ot=function(t,e,r,n){try{return n?e(l(r)[0],r[1]):e(r)}catch(e){var o=t.return;throw void 0!==o&&l(o.call(t)),e}},xt=e((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,r,n,o,i){var a,u,c,f,s,h,v,p=B(r,n,o?2:1);if(i)a=t;else{if("function"!=typeof(u=wt(t)))throw TypeError("Target is not iterable");if(ct(u)){for(c=0,f=vt(t.length);f>c;c++)if((s=o?p(l(v=t[c])[0],v[1]):p(t[c]))&&s instanceof e)return s;return new e(!1)}a=u.call(t)}for(h=a.next;!(v=h.call(a)).done;)if("object"==typeof(s=Ot(a,p,v.value,o))&&s&&s instanceof e)return s;return new e(!1)}).stop=function(t){return new e(!0,t)}})),kt=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},St=yt?{}.toString:function(){return"[object "+mt(this)+"]"},jt=p.f,At=ot("toStringTag"),Et=function(t,e,r,n){if(t){var o=r?t:t.prototype;O(o,At)||jt(o,At,{configurable:!0,value:e}),n&&!yt&&d(o,"toString",St)}},_t=function(t){return Object(M(t))},It=Array.isArray||function(t){return"Array"==P(t)},Tt=ot("species"),Pt=function(t,e){var r;return It(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!It(r.prototype)?a(r)&&null===(r=r[Tt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},Dt=[].push,Lt=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,f,s){for(var l,h,v=_t(u),p=L(v),y=B(c,f,3),d=vt(p.length),g=0,m=s||Pt,b=e?m(u,d):r?m(u,0):void 0;d>g;g++)if((a||g in p)&&(h=y(l=p[g],g,v),t))if(e)b[g]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return g;case 2:Dt.call(b,l)}else if(o)return!1;return i?-1:n||o?o:b}},Mt={forEach:Lt(0),map:Lt(1),filter:Lt(2),some:Lt(3),every:Lt(4),find:Lt(5),findIndex:Lt(6)},Ct=Function.toString;"function"!=typeof H.inspectSource&&(H.inspectSource=function(t){return Ct.call(t)});var Ft,Rt,Nt,zt=H.inspectSource,Gt=n.WeakMap,Ut="function"==typeof Gt&&/native code/.test(zt(Gt)),qt=X("keys"),Vt=function(t){return qt[t]||(qt[t]=S(t))},Wt=n.WeakMap;if(Ut){var Jt=new Wt,$t=Jt.get,Bt=Jt.has,Kt=Jt.set;Ft=function(t,e){return Kt.call(Jt,t,e),e},Rt=function(t){return $t.call(Jt,t)||{}},Nt=function(t){return Bt.call(Jt,t)}}else{var Qt=Vt("state");b[Qt]=!0,Ft=function(t,e){return d(t,Qt,e),e},Rt=function(t){return O(t,Qt)?t[Qt]:{}},Nt=function(t){return O(t,Qt)}}var Yt={set:Ft,get:Rt,has:Nt,enforce:function(t){return Nt(t)?Rt(t):Ft(t,{})},getterFor:function(t){return function(e){var r;if(!a(e)||(r=Rt(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Ht=p.f,Xt=Mt.forEach,Zt=Yt.set,te=Yt.getterFor,ee=function(t,e,r){var u,c=-1!==t.indexOf("Map"),f=-1!==t.indexOf("Weak"),s=c?"set":"add",l=n[t],h=l&&l.prototype,v={};if(i&&"function"==typeof l&&(f||h.forEach&&!o((function(){(new l).entries().next()})))){u=e((function(e,r){Zt(kt(e,u,t),{type:t,collection:new l}),null!=r&&xt(r,e[s],e,c)}));var p=te(t);Xt(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||f&&"clear"==t||d(u.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&f&&!a(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),f||Ht(u.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else u=r.getConstructor(e,t,c,s),A.REQUIRED=!0;return Et(u,t,!1,!0),v[t]=u,Y({global:!0,forced:!0},v),f||r.setStrong(u,t,c),u},re=A.getWeakData,ne=Yt.set,oe=Yt.getterFor,ie=Mt.find,ae=Mt.findIndex,ue=0,ce=function(t){return t.frozen||(t.frozen=new fe)},fe=function(){this.entries=[]},se=function(t,e){return ie(t.entries,(function(t){return t[0]===e}))};fe.prototype={get:function(t){var e=se(this,t);if(e)return e[1]},has:function(t){return!!se(this,t)},set:function(t,e){var r=se(this,t);r?r[1]=e:this.entries.push([t,e])},delete:function(t){var e=ae(this.entries,(function(e){return e[0]===t}));return~e&&this.entries.splice(e,1),!!~e}};var le,he,ve,pe={getConstructor:function(t,e,r,n){var o=t((function(t,i){kt(t,o,e),ne(t,{type:e,id:ue++,frozen:void 0}),null!=i&&xt(i,t[n],t,r)})),i=oe(e),u=function(t,e,r){var n=i(t),o=re(l(e),!0);return!0===o?ce(n).set(e,r):o[n.id]=r,t};return m(o.prototype,{delete:function(t){var e=i(this);if(!a(t))return!1;var r=re(t);return!0===r?ce(e).delete(t):r&&O(r,e.id)&&delete r[e.id]},has:function(t){var e=i(this);if(!a(t))return!1;var r=re(t);return!0===r?ce(e).has(t):r&&O(r,e.id)}}),m(o.prototype,r?{get:function(t){var e=i(this);if(a(t)){var r=re(t);return!0===r?ce(e).get(t):r?r[e.id]:void 0}},set:function(t,e){return u(this,t,e)}}:{add:function(t){return u(this,t,!0)}}),o}},ye=(e((function(t){var e,r=Yt.enforce,o=!n.ActiveXObject&&"ActiveXObject"in n,i=Object.isExtensible,u=function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}},c=t.exports=ee("WeakMap",u,pe);if(Ut&&o){e=pe.getConstructor(u,"WeakMap",!0),A.REQUIRED=!0;var f=c.prototype,s=f.delete,l=f.has,h=f.get,v=f.set;m(f,{delete:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),s.call(this,t)||n.frozen.delete(t)}return s.call(this,t)},has:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)||n.frozen.has(t)}return l.call(this,t)},get:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)?h.call(this,t):n.frozen.get(t)}return h.call(this,t)},set:function(t,n){if(a(t)&&!i(t)){var o=r(this);o.frozen||(o.frozen=new e),l.call(this,t)?v.call(this,t,n):o.frozen.set(t,n)}else v.call(this,t,n);return this}})}})),!o((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype}))),de=Vt("IE_PROTO"),ge=Object.prototype,me=ye?Object.getPrototypeOf:function(t){return t=_t(t),O(t,de)?t[de]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?ge:null},be=(ot("iterator"),!1);[].keys&&("next"in(ve=[].keys())?(he=me(me(ve)))!==Object.prototype&&(le=he):be=!0),null==le&&(le={});var we,Oe={IteratorPrototype:le,BUGGY_SAFARI_ITERATORS:be},xe=Math.max,ke=Math.min,Se=function(t,e){var r=lt(t);return r<0?xe(r+e,0):ke(r,e)},je=function(t){return function(e,r,n){var o,i=C(e),a=vt(i.length),u=Se(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},Ae={includes:je(!0),indexOf:je(!1)},Ee=Ae.indexOf,_e=function(t,e){var r,n=C(t),o=0,i=[];for(r in n)!O(b,r)&&O(n,r)&&i.push(r);for(;e.length>o;)O(n,r=e[o++])&&(~Ee(i,r)||i.push(r));return i},Ie=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Te=Object.keys||function(t){return _e(t,Ie)},Pe=i?Object.defineProperties:function(t,e){l(t);for(var r,n=Te(e),o=n.length,i=0;o>i;)p.f(t,r=n[i++],e[r]);return t},De=function(t){return"function"==typeof t?t:void 0},Le=function(t,e){return arguments.length<2?De(J[t])||De(n[t]):J[t]&&J[t][e]||n[t]&&n[t][e]},Me=Le("document","documentElement"),Ce=Vt("IE_PROTO"),Fe=function(){},Re=function(t){return"<script>"+t+"<\/script>"},Ne=function(){try{we=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ne=we?function(t){t.write(Re("")),t.close();var e=t.parentWindow.Object;return t=null,e}(we):((e=f("iframe")).style.display="none",Me.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Re("document.F=Object")),t.close(),t.F);for(var r=Ie.length;r--;)delete Ne.prototype[Ie[r]];return Ne()};b[Ce]=!0;var ze=Object.create||function(t,e){var r;return null!==t?(Fe.prototype=l(t),r=new Fe,Fe.prototype=null,r[Ce]=t):r=Ne(),void 0===e?r:Pe(r,e)},Ge=Oe.IteratorPrototype,Ue=function(){return this},qe=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return l(r),function(t){if(!a(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Ve=Oe.IteratorPrototype,We=Oe.BUGGY_SAFARI_ITERATORS,Je=ot("iterator"),$e=function(){return this},Be=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=ze(Ge,{next:y(1,r)}),Et(t,n,!1,!0),it[n]=Ue}(r,e,n);var u,c,f,s=function(t){if(t===o&&m)return m;if(!We&&t in v)return v[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",h=!1,v=t.prototype,p=v[Je]||v["@@iterator"]||o&&v[o],m=!We&&p||s(o),b="Array"==e&&v.entries||p;if(b&&(u=me(b.call(new t)),Ve!==Object.prototype&&u.next&&(Et(u,l,!0,!0),it[l]=$e)),"values"==o&&p&&"values"!==p.name&&(h=!0,m=function(){return p.call(this)}),a&&v[Je]!==m&&d(v,Je,m),it[e]=m,o)if(c={values:s("values"),keys:i?m:s("keys"),entries:s("entries")},a)for(f in c)(We||h||!(f in v))&&g(v,f,c[f]);else Y({target:e,proto:!0,forced:We||h},c);return c},Ke=Yt.set,Qe=Yt.getterFor("Array Iterator");Be(Array,"Array",(function(t,e){Ke(this,{type:"Array Iterator",target:C(t),index:0,kind:e})}),(function(){var t=Qe(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");it.Arguments=it.Array;var Ye=ot("toStringTag");for(var He in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Xe=n[He],Ze=Xe&&Xe.prototype;Ze&&mt(Ze)!==Ye&&d(Ze,Ye,He),it[He]=it.Array}var tr=J.WeakMap,er=function(t,e,r,n,o,i,a,u){for(var c,f=o,s=0,l=!!a&&B(a,u,3);s<n;){if(s in r){if(c=l?l(r[s],s,e):r[s],i>0&&It(c))f=er(t,e,c,vt(c.length),f,i-1)-1;else{if(f>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[f]=c}f++}s++}return f},rr=er;Y({target:"Array",proto:!0},{flatMap:function(t){var e,r=_t(this),n=vt(r.length);return $(t),(e=Pt(r,0)).length=rr(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var nr,or,ir=function(t){return J[t+"Prototype"]},ar=ir("Array").flatMap,ur=Array.prototype,cr=function(t){var e=t.flatMap;return t===ur||t instanceof Array&&e===ur.flatMap?ar:e},fr=Le("navigator","userAgent")||"",sr=n.process,lr=sr&&sr.versions,hr=lr&&lr.v8;hr?or=(nr=hr.split("."))[0]+nr[1]:fr&&(!(nr=fr.match(/Edge\/(\d+)/))||nr[1]>=74)&&(nr=fr.match(/Chrome\/(\d+)/))&&(or=nr[1]);var vr=or&&+or,pr=ot("species"),yr=function(t){return vr>=51||!o((function(){var e=[];return(e.constructor={})[pr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},dr=Object.defineProperty,gr={},mr=function(t){throw t},br=function(t,e){if(O(gr,t))return gr[t];e||(e={});var r=[][t],n=!!O(e,"ACCESSORS")&&e.ACCESSORS,a=O(e,0)?e[0]:mr,u=O(e,1)?e[1]:void 0;return gr[t]=!!r&&!o((function(){if(n&&!i)return!0;var t={length:-1};n?dr(t,1,{enumerable:!0,get:mr}):t[1]=1,r.call(t,a,u)}))},wr=Mt.map,Or=yr("map"),xr=br("map");Y({target:"Array",proto:!0,forced:!Or||!xr},{map:function(t){return wr(this,t,arguments.length>1?arguments[1]:void 0)}});var kr=ir("Array").map,Sr=Array.prototype,jr=function(t){var e=t.map;return t===Sr||t instanceof Array&&e===Sr.map?kr:e},Ar=Mt.filter,Er=yr("filter"),_r=br("filter");Y({target:"Array",proto:!0,forced:!Er||!_r},{filter:function(t){return Ar(this,t,arguments.length>1?arguments[1]:void 0)}});var Ir=ir("Array").filter,Tr=Array.prototype,Pr=function(t){var e=t.filter;return t===Tr||t instanceof Array&&e===Tr.filter?Ir:e},Dr=function(t){return function(e,r,n,o){$(r);var i=_t(e),a=L(i),u=vt(i.length),c=t?u-1:0,f=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=f;break}if(c+=f,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=f)c in a&&(o=r(o,a[c],c,i));return o}},Lr=function(t,e){var r=[][t];return!!r&&o((function(){r.call(null,e||function(){throw 1},1)}))},Mr={left:Dr(!1),right:Dr(!0)}.left,Cr=Lr("reduce"),Fr=br("reduce",{1:0});Y({target:"Array",proto:!0,forced:!Cr||!Fr},{reduce:function(t){return Mr(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Rr=ir("Array").reduce,Nr=Array.prototype,zr=function(t){var e=t.reduce;return t===Nr||t instanceof Array&&e===Nr.reduce?Rr:e},Gr=[].slice,Ur={},qr=function(t,e,r){if(!(e in Ur)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Ur[e]=Function("C,a","return new C("+n.join(",")+")")}return Ur[e](t,r)},Vr=Function.bind||function(t){var e=$(this),r=Gr.call(arguments,1),n=function(){var o=r.concat(Gr.call(arguments));return this instanceof n?qr(e,o.length,o):e.apply(t,o)};return a(e.prototype)&&(n.prototype=e.prototype),n};Y({target:"Function",proto:!0},{bind:Vr});var Wr=ir("Function").bind,Jr=Function.prototype,$r=function(t){var e=t.bind;return t===Jr||t instanceof Function&&e===Jr.bind?Wr:e};var Br=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};Y({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperty:p.f});var Kr=e((function(t){var e=J.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),Qr=Kr;function Yr(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Qr(t,n.key,n)}}var Hr,Xr=function(t,e,r){return e&&Yr(t.prototype,e),r&&Yr(t,r),t};
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */function Zr(t,e){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return e.get(t)}function tn(t,e,r){if(!e.has(t))throw new TypeError("attempted to set private field on non-instance");return e.set(t,r),r}function en(t){return new nn(t)}var rn=function(){function t(e,r,n){var o,i,a;Br(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:$r(o=this._add).call(o,this),remove:$r(i=this._remove).call(i,this),update:$r(a=this._update).call(a,this)}}return Xr(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return zr(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),nn=function(){function t(e){Br(this,t),this._source=e,Hr.set(this,[])}return Xr(t,[{key:"filter",value:function(t){return Zr(this,Hr).push((function(e){return Pr(e).call(e,t)})),this}},{key:"map",value:function(t){return Zr(this,Hr).push((function(e){return jr(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return Zr(this,Hr).push((function(e){return cr(e).call(e,t)})),this}},{key:"to",value:function(t){return new rn(this._source,Zr(this,Hr),t)}}]),t}();Hr=new tr;var on=Kr;Y({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperties:Pe});var an=e((function(t){var e=J.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),un=Ie.concat("length","prototype"),cn={f:Object.getOwnPropertyNames||function(t){return _e(t,un)}},fn={f:Object.getOwnPropertySymbols},sn=Le("Reflect","ownKeys")||function(t){var e=cn.f(l(t)),r=fn.f;return r?e.concat(r(t)):e},ln=function(t,e,r){var n=h(e);n in t?p.f(t,n,y(0,r)):t[n]=r};Y({target:"Object",stat:!0,sham:!i},{getOwnPropertyDescriptors:function(t){for(var e,r,n=C(t),o=R.f,i=sn(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&ln(a,e,r);return a}});var hn=J.Object.getOwnPropertyDescriptors,vn=R.f,pn=o((function(){vn(1)}));Y({target:"Object",stat:!0,forced:!i||pn,sham:!i},{getOwnPropertyDescriptor:function(t,e){return vn(C(t),e)}});var yn=e((function(t){var e=J.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),dn=cn.f,gn={}.toString,mn="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],bn={f:function(t){return mn&&"[object Window]"==gn.call(t)?function(t){try{return dn(t)}catch(t){return mn.slice()}}(t):dn(C(t))}},wn={f:ot},On=p.f,xn=function(t){var e=J.Symbol||(J.Symbol={});O(e,t)||On(e,t,{value:wn.f(t)})},kn=Mt.forEach,Sn=Vt("hidden"),jn=ot("toPrimitive"),An=Yt.set,En=Yt.getterFor("Symbol"),_n=Object.prototype,In=n.Symbol,Tn=Le("JSON","stringify"),Pn=R.f,Dn=p.f,Ln=bn.f,Mn=I.f,Cn=X("symbols"),Fn=X("op-symbols"),Rn=X("string-to-symbol-registry"),Nn=X("symbol-to-string-registry"),zn=X("wks"),Gn=n.QObject,Un=!Gn||!Gn.prototype||!Gn.prototype.findChild,qn=i&&o((function(){return 7!=ze(Dn({},"a",{get:function(){return Dn(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Pn(_n,e);n&&delete _n[e],Dn(t,e,r),n&&t!==_n&&Dn(_n,e,n)}:Dn,Vn=function(t,e){var r=Cn[t]=ze(In.prototype);return An(r,{type:"Symbol",tag:t,description:e}),i||(r.description=e),r},Wn=tt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof In},Jn=function(t,e,r){t===_n&&Jn(Fn,e,r),l(t);var n=h(e,!0);return l(r),O(Cn,n)?(r.enumerable?(O(t,Sn)&&t[Sn][n]&&(t[Sn][n]=!1),r=ze(r,{enumerable:y(0,!1)})):(O(t,Sn)||Dn(t,Sn,y(1,{})),t[Sn][n]=!0),qn(t,n,r)):Dn(t,n,r)},$n=function(t,e){l(t);var r=C(e),n=Te(r).concat(Yn(r));return kn(n,(function(e){i&&!Bn.call(r,e)||Jn(t,e,r[e])})),t},Bn=function(t){var e=h(t,!0),r=Mn.call(this,e);return!(this===_n&&O(Cn,e)&&!O(Fn,e))&&(!(r||!O(this,e)||!O(Cn,e)||O(this,Sn)&&this[Sn][e])||r)},Kn=function(t,e){var r=C(t),n=h(e,!0);if(r!==_n||!O(Cn,n)||O(Fn,n)){var o=Pn(r,n);return!o||!O(Cn,n)||O(r,Sn)&&r[Sn][n]||(o.enumerable=!0),o}},Qn=function(t){var e=Ln(C(t)),r=[];return kn(e,(function(t){O(Cn,t)||O(b,t)||r.push(t)})),r},Yn=function(t){var e=t===_n,r=Ln(e?Fn:C(t)),n=[];return kn(r,(function(t){!O(Cn,t)||e&&!O(_n,t)||n.push(Cn[t])})),n};if(Z||(g((In=function(){if(this instanceof In)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=S(t),r=function(t){this===_n&&r.call(Fn,t),O(this,Sn)&&O(this[Sn],e)&&(this[Sn][e]=!1),qn(this,e,y(1,t))};return i&&Un&&qn(_n,e,{configurable:!0,set:r}),Vn(e,t)}).prototype,"toString",(function(){return En(this).tag})),g(In,"withoutSetter",(function(t){return Vn(S(t),t)})),I.f=Bn,p.f=Jn,R.f=Kn,cn.f=bn.f=Qn,fn.f=Yn,wn.f=function(t){return Vn(ot(t),t)},i&&Dn(In.prototype,"description",{configurable:!0,get:function(){return En(this).description}})),Y({global:!0,wrap:!0,forced:!Z,sham:!Z},{Symbol:In}),kn(Te(zn),(function(t){xn(t)})),Y({target:"Symbol",stat:!0,forced:!Z},{for:function(t){var e=String(t);if(O(Rn,e))return Rn[e];var r=In(e);return Rn[e]=r,Nn[r]=e,r},keyFor:function(t){if(!Wn(t))throw TypeError(t+" is not a symbol");if(O(Nn,t))return Nn[t]},useSetter:function(){Un=!0},useSimple:function(){Un=!1}}),Y({target:"Object",stat:!0,forced:!Z,sham:!i},{create:function(t,e){return void 0===e?ze(t):$n(ze(t),e)},defineProperty:Jn,defineProperties:$n,getOwnPropertyDescriptor:Kn}),Y({target:"Object",stat:!0,forced:!Z},{getOwnPropertyNames:Qn,getOwnPropertySymbols:Yn}),Y({target:"Object",stat:!0,forced:o((function(){fn.f(1)}))},{getOwnPropertySymbols:function(t){return fn.f(_t(t))}}),Tn){var Hn=!Z||o((function(){var t=In();return"[null]"!=Tn([t])||"{}"!=Tn({a:t})||"{}"!=Tn(Object(t))}));Y({target:"JSON",stat:!0,forced:Hn},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(a(e)||void 0!==t)&&!Wn(t))return It(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Wn(e))return e}),o[1]=e,Tn.apply(null,o)}})}In.prototype[jn]||d(In.prototype,jn,In.prototype.valueOf),Et(In,"Symbol"),b[Sn]=!0;var Xn=J.Object.getOwnPropertySymbols,Zn=function(t){return function(e,r){var n,o,i=String(M(e)),a=lt(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},to={codeAt:Zn(!1),charAt:Zn(!0)}.charAt,eo=Yt.set,ro=Yt.getterFor("String Iterator");Be(String,"String",(function(t){eo(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=ro(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=to(r,n),e.index+=t.length,{value:t,done:!1})}));var no=function(t){var e=wt(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return l(e.call(t))},oo=wt,io=ot("iterator"),ao=!1;try{var uo=0,co={next:function(){return{done:!!uo++}},return:function(){ao=!0}};co[io]=function(){return this},Array.from(co,(function(){throw 2}))}catch(t){}var fo=!function(t,e){if(!e&&!ao)return!1;var r=!1;try{var n={};n[io]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));Y({target:"Array",stat:!0,forced:fo},{from:function(t){var e,r,n,o,i,a,u=_t(t),c="function"==typeof this?this:Array,f=arguments.length,s=f>1?arguments[1]:void 0,l=void 0!==s,h=wt(u),v=0;if(l&&(s=B(s,f>2?arguments[2]:void 0,2)),null==h||c==Array&&ct(h))for(r=new c(e=vt(u.length));e>v;v++)a=l?s(u[v],v):u[v],ln(r,v,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;v++)a=l?Ot(o,s,[n.value,v],!0):n.value,ln(r,v,a);return r.length=v,r}});var so=J.Array.from,lo=so;Y({target:"Object",stat:!0,sham:!i},{create:ze});var ho=J.Object,vo=function(t,e){return ho.create(t,e)},po=vo;var yo,go=function(t,e,r){return e in t?Qr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},mo="\t\n\v\f\r                　\u2028\u2029\ufeff",bo="["+mo+"]",wo=RegExp("^"+bo+bo+"*"),Oo=RegExp(bo+bo+"*$"),xo=function(t){return function(e){var r=String(M(e));return 1&t&&(r=r.replace(wo,"")),2&t&&(r=r.replace(Oo,"")),r}},ko={start:xo(1),end:xo(2),trim:xo(3)},So=ko.trim;Y({target:"String",proto:!0,forced:(yo="trim",o((function(){return!!mo[yo]()||"​᠎"!="​᠎"[yo]()||mo[yo].name!==yo})))},{trim:function(){return So(this)}});ir("String").trim;var jo=Mt.forEach,Ao=Lr("forEach"),Eo=br("forEach"),_o=Ao&&Eo?[].forEach:function(t){return jo(this,t,arguments.length>1?arguments[1]:void 0)};Y({target:"Array",proto:!0,forced:[].forEach!=_o},{forEach:_o});var Io=ir("Array").forEach,To=Array.prototype,Po={DOMTokenList:!0,NodeList:!0},Do=function(t){var e=t.forEach;return t===To||t instanceof Array&&e===To.forEach||Po.hasOwnProperty(mt(t))?Io:e},Lo=ko.trim,Mo=n.parseInt,Co=/^[+-]?0[Xx]/,Fo=8!==Mo(mo+"08")||22!==Mo(mo+"0x16")?function(t,e){var r=Lo(String(t));return Mo(r,e>>>0||(Co.test(r)?16:10))}:Mo;Y({global:!0,forced:parseInt!=Fo},{parseInt:Fo});var Ro=I.f,No=function(t){return function(e){for(var r,n=C(e),o=Te(n),a=o.length,u=0,c=[];a>u;)r=o[u++],i&&!Ro.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},zo={entries:No(!0),values:No(!1)}.values;Y({target:"Object",stat:!0},{values:function(t){return zo(t)}});J.Object.values;var Go=o((function(){me(1)}));Y({target:"Object",stat:!0,forced:Go,sham:!ye},{getPrototypeOf:function(t){return me(_t(t))}});var Uo=J.Object.getPrototypeOf,qo=Ae.indexOf,Vo=[].indexOf,Wo=!!Vo&&1/[1].indexOf(1,-0)<0,Jo=Lr("indexOf"),$o=br("indexOf",{ACCESSORS:!0,1:0});Y({target:"Array",proto:!0,forced:Wo||!Jo||!$o},{indexOf:function(t){return Wo?Vo.apply(this,arguments)||0:qo(this,t,arguments.length>1?arguments[1]:void 0)}});ir("Array").indexOf;var Bo=Object.assign,Ko=Object.defineProperty,Qo=!Bo||o((function(){if(i&&1!==Bo({b:1},Bo(Ko({},"a",{enumerable:!0,get:function(){Ko(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Bo({},t)[r]||Te(Bo({},e)).join("")!=n}))?function(t,e){for(var r=_t(t),n=arguments.length,o=1,a=fn.f,u=I.f;n>o;)for(var c,f=L(arguments[o++]),s=a?Te(f).concat(a(f)):Te(f),l=s.length,h=0;l>h;)c=s[h++],i&&!u.call(f,c)||(r[c]=f[c]);return r}:Bo;Y({target:"Object",stat:!0,forced:Object.assign!==Qo},{assign:Qo});var Yo=J.Object.assign;Y({target:"Array",stat:!0},{isArray:It});var Ho=J.Array.isArray,Xo=Ho;var Zo=function(t){if(Xo(t))return t},ti=ot("iterator"),ei=function(t){var e=Object(t);return void 0!==e[ti]||"@@iterator"in e||it.hasOwnProperty(mt(e))},ri=ot("isConcatSpreadable"),ni=vr>=51||!o((function(){var t=[];return t[ri]=!1,t.concat()[0]!==t})),oi=yr("concat"),ii=function(t){if(!a(t))return!1;var e=t[ri];return void 0!==e?!!e:It(t)};Y({target:"Array",proto:!0,forced:!ni||!oi},{concat:function(t){var e,r,n,o,i,a=_t(this),u=Pt(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(ii(i=-1===e?a:arguments[e])){if(c+(o=vt(i.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<o;r++,c++)r in i&&ln(u,c,i[r])}else{if(c>=9007199254740991)throw TypeError("Maximum allowed index exceeded");ln(u,c++,i)}return u.length=c,u}}),xn("asyncIterator"),xn("hasInstance"),xn("isConcatSpreadable"),xn("iterator"),xn("match"),xn("matchAll"),xn("replace"),xn("search"),xn("species"),xn("split"),xn("toPrimitive"),xn("toStringTag"),xn("unscopables"),Et(Math,"Math",!0),Et(n.JSON,"JSON",!0);var ai=J.Symbol;xn("asyncDispose"),xn("dispose"),xn("observable"),xn("patternMatch"),xn("replaceAll");var ui=ai;var ci=function(t,e){if(void 0!==ui&&ei(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=no(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}},fi=so,si=yr("slice"),li=br("slice",{ACCESSORS:!0,0:0,1:2}),hi=ot("species"),vi=[].slice,pi=Math.max;Y({target:"Array",proto:!0,forced:!si||!li},{slice:function(t,e){var r,n,o,i=C(this),u=vt(i.length),c=Se(t,u),f=Se(void 0===e?u:e,u);if(It(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!It(r.prototype)?a(r)&&null===(r=r[hi])&&(r=void 0):r=void 0,r===Array||void 0===r))return vi.call(i,c,f);for(n=new(void 0===r?Array:r)(pi(f-c,0)),o=0;c<f;c++,o++)c in i&&ln(n,o,i[c]);return n.length=o,n}});var yi=ir("Array").slice,di=Array.prototype,gi=function(t){var e=t.slice;return t===di||t instanceof Array&&e===di.slice?yi:e},mi=gi;var bi=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var wi=function(t,e){var r;if(t){if("string"==typeof t)return bi(t,e);var n=mi(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?fi(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?bi(t,e):void 0}};var Oi=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var xi=function(t,e){return Zo(t)||ci(t,e)||wi(t,e)||Oi()};Y({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});J.Date.now;var ki=o((function(){Te(1)}));Y({target:"Object",stat:!0,forced:ki},{keys:function(t){return Te(_t(t))}});var Si=J.Object.keys,ji=Ho,Ai=wn.f("iterator"),Ei=Ai,_i=e((function(t){function e(r){return t.exports=e="function"==typeof ui&&"symbol"==typeof Ei?function(t){return typeof t}:function(t){return t&&"function"==typeof ui&&t.constructor===ui&&t!==ui.prototype?"symbol":typeof t},e(r)}t.exports=e}));Y({target:"Reflect",stat:!0},{ownKeys:sn});var Ii=J.Reflect.ownKeys,Ti=gi;var Pi=function(t){if(Xo(t))return bi(t)};var Di=function(t){if(void 0!==ui&&ei(Object(t)))return fi(t)};var Li=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Mi=function(t){return Pi(t)||Di(t)||wi(t)||Li()},Ci=ir("Array").concat,Fi=Array.prototype,Ri=function(t){var e=t.concat;return t===Fi||t instanceof Array&&e===Fi.concat?Ci:e},Ni=ai;function zi(t,e){var r;if(void 0===Ni||null==oo(t)){if(ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Gi(t,e);var n=Ti(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return lo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gi(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=no(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Gi(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.4
 * @date    2020-08-01T15:11:53.524Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var Ui=Ni("DELETE");function qi(){var t=Vi.apply(void 0,arguments);return Ji(t),t}function Vi(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Vi.apply(void 0,Ri(n=[qi(e[0],e[1])]).call(n,Mi(Ti(e).call(e,2))));var o,i=e[0],a=e[1],u=zi(Ii(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===Ui?delete i[c]:null===i[c]||null===a[c]||"object"!==_i(i[c])||"object"!==_i(a[c])||ji(i[c])||ji(a[c])?i[c]=Wi(a[c]):i[c]=Vi(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function Wi(t){return ji(t)?jr(t).call(t,(function(t){return Wi(t)})):"object"===_i(t)&&null!==t?Vi({},t):t}function Ji(t){for(var e=0,r=Si(t);e<r.length;e++){var n=r[e];t[n]===Ui?delete t[n]:"object"===_i(t[n])&&null!==t[n]&&Ji(t[n])}}var $i=Le("Reflect","construct"),Bi=o((function(){function t(){}return!($i((function(){}),[],t)instanceof t)})),Ki=!o((function(){$i((function(){}))})),Qi=Bi||Ki;Y({target:"Reflect",stat:!0,forced:Qi,sham:Qi},{construct:function(t,e){$(t),l(e);var r=arguments.length<3?t:$(arguments[2]);if(Ki&&!Bi)return $i(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Vr.apply(t,n))}var o=r.prototype,i=ze(a(o)?o:Object.prototype),u=Function.apply.call(t,i,e);return a(u)?u:i}});var Yi=J.Reflect.construct,Hi=ir("Array").entries,Xi=Array.prototype,Zi={DOMTokenList:!0,NodeList:!0},ta=function(t){var e=t.entries;return t===Xi||t instanceof Array&&e===Xi.entries||Zi.hasOwnProperty(mt(t))?Hi:e},ea=e((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function c(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{c({},"")}catch(t){c=function(t,e,r){return t[e]=r}}function f(t,e,r,n){var o=e&&e.prototype instanceof d?e:d,i=Object.create(o.prototype),a=new _(n||[]);return i._invoke=function(t,e,r){var n=l;return function(o,i){if(n===v)throw new Error("Generator is already running");if(n===p){if("throw"===o)throw i;return T()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=j(a,r);if(u){if(u===y)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===l)throw n=p,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=v;var c=s(t,e,r);if("normal"===c.type){if(n=r.done?p:h,c.arg===y)continue;return{value:c.arg,done:r.done}}"throw"===c.type&&(n=p,r.method="throw",r.arg=c.arg)}}}(t,r,a),i}function s(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=f;var l="suspendedStart",h="suspendedYield",v="executing",p="completed",y={};function d(){}function g(){}function m(){}var b={};b[i]=function(){return this};var w=Object.getPrototypeOf,O=w&&w(w(I([])));O&&O!==r&&n.call(O,i)&&(b=O);var x=m.prototype=d.prototype=Object.create(b);function k(t){["next","throw","return"].forEach((function(e){c(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(o,i,a,u){var c=s(t[o],t,i);if("throw"!==c.type){var f=c.arg,l=f.value;return l&&"object"==typeof l&&n.call(l,"__await")?e.resolve(l.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(l).then((function(t){f.value=t,a(f)}),(function(t){return r("throw",t,a,u)}))}u(c.arg)}var o;this._invoke=function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}}function j(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,j(t,r),"throw"===r.method))return y;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return y}var o=s(n,t.iterator,r.arg);if("throw"===o.type)return r.method="throw",r.arg=o.arg,r.delegate=null,y;var i=o.arg;return i?i.done?(r[t.resultName]=i.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,y):i:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,y)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function E(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function _(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function I(t){if(t){var r=t[i];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(n.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:T}}function T(){return{value:e,done:!0}}return g.prototype=x.constructor=m,m.constructor=g,g.displayName=c(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,c(t,u,"GeneratorFunction")),t.prototype=Object.create(x),t},t.awrap=function(t){return{__await:t}},k(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new S(f(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},k(x),c(x,u,"Generator"),x[i]=function(){return this},x.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=I,_.prototype={constructor:_,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(E),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function o(n,o){return u.type="throw",u.arg=t,r.next=n,o&&(r.method="next",r.arg=e),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],u=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=n.call(a,"catchLoc"),f=n.call(a,"finallyLoc");if(c&&f){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!f)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,y):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),y},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),E(r),y}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;E(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:I(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),y}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),ra=Ai,na=Le("JSON","stringify"),oa=/[\uD800-\uDFFF]/g,ia=/^[\uD800-\uDBFF]$/,aa=/^[\uDC00-\uDFFF]$/,ua=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return ia.test(t)&&!aa.test(o)||aa.test(t)&&!ia.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},ca=o((function(){return'"\\udf06\\ud834"'!==na("\udf06\ud834")||'"\\udead"'!==na("\udead")}));na&&Y({target:"JSON",stat:!0,forced:ca},{stringify:function(t,e,r){var n=na.apply(null,arguments);return"string"==typeof n?n.replace(oa,ua):n}}),J.JSON||(J.JSON={stringify:JSON.stringify});var fa=function(t,e,r){return J.JSON.stringify.apply(null,arguments)},sa=ir("Array").values,la=Array.prototype,ha={DOMTokenList:!0,NodeList:!0},va=function(t){var e=t.values;return t===la||t instanceof Array&&e===la.values||ha.hasOwnProperty(mt(t))?sa:e},pa=[],ya=pa.sort,da=o((function(){pa.sort(void 0)})),ga=o((function(){pa.sort(null)})),ma=Lr("sort");Y({target:"Array",proto:!0,forced:da||!ga||!ma},{sort:function(t){return void 0===t?ya.call(_t(this)):ya.call(_t(this),$(t))}});var ba=ir("Array").sort,wa=Array.prototype,Oa=function(t){var e=t.sort;return t===wa||t instanceof Array&&e===wa.sort?ba:e},xa=ir("Array").keys,ka=Array.prototype,Sa={DOMTokenList:!0,NodeList:!0},ja=function(t){var e=t.keys;return t===ka||t instanceof Array&&e===ka.keys||Sa.hasOwnProperty(mt(t))?xa:e},Aa=Mt.some,Ea=Lr("some"),_a=br("some");Y({target:"Array",proto:!0,forced:!Ea||!_a},{some:function(t){return Aa(this,t,arguments.length>1?arguments[1]:void 0)}});var Ia=ir("Array").some,Ta=Array.prototype,Pa=function(t){var e=t.some;return t===Ta||t instanceof Array&&e===Ta.some?Ia:e},Da=ot("species"),La=p.f,Ma=A.fastKey,Ca=Yt.set,Fa=Yt.getterFor,Ra={getConstructor:function(t,e,r,n){var o=t((function(t,a){kt(t,o,e),Ca(t,{type:e,index:ze(null),first:void 0,last:void 0,size:0}),i||(t.size=0),null!=a&&xt(a,t[n],t,r)})),a=Fa(e),u=function(t,e,r){var n,o,u=a(t),f=c(t,e);return f?f.value=r:(u.last=f={index:o=Ma(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=f),n&&(n.next=f),i?u.size++:t.size++,"F"!==o&&(u.index[o]=f)),t},c=function(t,e){var r,n=a(t),o=Ma(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return m(o.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,i?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=c(e,t);if(n){var o=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=o),o&&(o.previous=u),r.first==n&&(r.first=o),r.last==n&&(r.last=u),i?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=B(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),m(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),i&&La(o.prototype,"size",{get:function(){return a(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=Fa(e),a=Fa(n);Be(t,e,(function(t,e){Ca(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=Le(t),r=p.f;i&&e&&!e[Da]&&r(e,Da,{configurable:!0,get:function(){return this}})}(e)}},Na=(ee("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ra),J.Map);var za=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},Ga=vo;Y({target:"Object",stat:!0},{setPrototypeOf:qe});var Ua=J.Object.setPrototypeOf,qa=e((function(t){function e(r,n){return t.exports=e=Ua||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var Va=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Ga(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&qa(t,e)};var Wa=function(t,e){return!e||"object"!==_i(e)&&"function"!=typeof e?za(t):e},Ja=Uo,$a=e((function(t){function e(r){return t.exports=e=Ua?Ja:function(t){return t.__proto__||Ja(t)},e(r)}t.exports=e})),Ba="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Ka=new Uint8Array(16);function Qa(){if(!Ba)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Ba(Ka)}var Ya=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function Ha(t){return"string"==typeof t&&Ya.test(t)}for(var Xa=[],Za=0;Za<256;++Za)Xa.push((Za+256).toString(16).substr(1));function tu(t,e,r){var n=(t=t||{}).random||(t.rng||Qa)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Xa[t[e+0]]+Xa[t[e+1]]+Xa[t[e+2]]+Xa[t[e+3]]+"-"+Xa[t[e+4]]+Xa[t[e+5]]+"-"+Xa[t[e+6]]+Xa[t[e+7]]+"-"+Xa[t[e+8]]+Xa[t[e+9]]+"-"+Xa[t[e+10]]+Xa[t[e+11]]+Xa[t[e+12]]+Xa[t[e+13]]+Xa[t[e+14]]+Xa[t[e+15]]).toLowerCase();if(!Ha(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function eu(t){return"string"==typeof t||"number"==typeof t}var ru=yr("splice"),nu=br("splice",{ACCESSORS:!0,0:0,1:2}),ou=Math.max,iu=Math.min;Y({target:"Array",proto:!0,forced:!ru||!nu},{splice:function(t,e){var r,n,o,i,a,u,c=_t(this),f=vt(c.length),s=Se(t,f),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=f-s):(r=l-2,n=iu(ou(lt(e),0),f-s)),f+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=Pt(c,n),i=0;i<n;i++)(a=s+i)in c&&ln(o,i,c[a]);if(o.length=n,r<n){for(i=s;i<f-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=f;i>f-n+r;i--)delete c[i-1]}else if(r>n)for(i=f-n;i>s;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+s]=arguments[i+2];return c.length=f-n+r,o}});var au=ir("Array").splice,uu=Array.prototype,cu=function(t){var e=t.splice;return t===uu||t instanceof Array&&e===uu.splice?au:e},fu=[].slice,su=/MSIE .\./.test(fr),lu=function(t){return function(e,r){var n=arguments.length>2,o=n?fu.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};Y({global:!0,bind:!0,forced:su},{setTimeout:lu(n.setTimeout),setInterval:lu(n.setInterval)});var hu,vu,pu,yu,du=J.setTimeout,gu=function(){function t(e){Br(this,t),hu.set(this,[]),vu.set(this,null),pu.set(this,null),this.delay=null,this.max=1/0,this.setOptions(e)}return Xr(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),Zr(this,pu)){for(var t=Zr(this,pu).object,e=Zr(this,pu).methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}tn(this,pu,null)}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?Zr(this,hu).push({fn:t}):Zr(this,hu).push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;Zr(this,hu).length>this.max&&this.flush(),null!=Zr(this,vu)&&(clearTimeout(Zr(this,vu)),tn(this,vu,null)),this.queue.length>0&&"number"==typeof this.delay&&tn(this,vu,du((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Do(t=cu(e=Zr(this,hu)).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return tn(n,pu,{object:e,methods:o}),n}}]),t}();hu=new tr,vu=new tr,pu=new tr;var mu=function(){function t(){Br(this,t),yu.set(this,{"*":[],add:[],remove:[],update:[]}),this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Xr(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Do(n=Ri(o=[]).call(o,Mi(Zr(this,yu)[t]),Mi(Zr(this,yu)["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&Zr(this,yu)[t].push(e)}},{key:"off",value:function(t,e){var r;Zr(this,yu)[t]=Pr(r=Zr(this,yu)[t]).call(r,(function(t){return t!==e}))}}]),t}();yu=new tr;ee("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ra);var bu,wu=J.Set;function Ou(t,e){var r;if(void 0===Ni||null==oo(t)){if(ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return xu(t,e);var n=Ti(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return lo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=no(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function xu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var ku,Su,ju,Au,Eu=function(){function t(e){Br(this,t),bu.set(this,void 0),tn(this,bu,e)}return Xr(t,[{key:(bu=new tr,ra),value:ea.mark((function t(){var e,r,n,o,i;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ou(Zr(this,bu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=xi(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:ea.mark((function t(){var e,r,n,o,i;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ou(Zr(this,bu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=xi(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:ea.mark((function t(){var e,r,n,o;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ou(Zr(this,bu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=xi(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:ea.mark((function t(){var e,r,n,o;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ou(Zr(this,bu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=xi(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return jr(t=Mi(Zr(this,bu))).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return jr(t=Mi(Zr(this,bu))).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Mi(Zr(this,bu))}},{key:"toObjectMap",value:function(){var t,e=po(null),r=Ou(Zr(this,bu));try{for(r.s();!(t=r.n()).done;){var n=xi(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Na(Zr(this,bu))}},{key:"toIdSet",value:function(){return new wu(this.toIdArray())}},{key:"toItemSet",value:function(){return new wu(this.toItemArray())}},{key:"cache",value:function(){return new t(Mi(Zr(this,bu)))}},{key:"distinct",value:function(t){var e,r=new wu,n=Ou(Zr(this,bu));try{for(n.s();!(e=n.n()).done;){var o=xi(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=Zr(this,bu);return new t(go({},ra,ea.mark((function t(){var n,o,i,a,u;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Ou(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=xi(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Ou(Zr(this,bu));try{for(r.s();!(e=r.n()).done;){var n=xi(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=Zr(this,bu);return new t(go({},ra,ea.mark((function t(){var n,o,i,a,u;return ea.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Ou(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=xi(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=no(Zr(this,bu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=xi(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=no(Zr(this,bu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=xi(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Ou(Zr(this,bu));try{for(n.s();!(r=n.n()).done;){var o=xi(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(go({},ra,(function(){var t;return no(Oa(t=Mi(Zr(r,bu))).call(t,(function(t,r){var n=xi(t,2),o=n[0],i=n[1],a=xi(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function _u(t,e){var r=Si(t);if(Xn){var n=Xn(t);e&&(n=Pr(n).call(n,(function(e){return yn(t,e).enumerable}))),r.push.apply(r,n)}return r}function Iu(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)Do(r=_u(Object(n),!0)).call(r,(function(e){go(t,e,n[e])}));else if(hn)an(t,hn(n));else{var o;Do(o=_u(Object(n))).call(o,(function(e){on(t,e,yn(n,e))}))}}return t}function Tu(t,e){var r;if(void 0===Ni||null==oo(t)){if(ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Pu(t,e);var n=Ti(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return lo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Pu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=no(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Pu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Du(t){var e=function(){if("undefined"==typeof Reflect||!Yi)return!1;if(Yi.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Yi(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=$a(t);if(e){var o=$a(this).constructor;r=Yi(n,arguments,o)}else r=n.apply(this,arguments);return Wa(this,r)}}var Lu,Mu,Cu,Fu,Ru=function(t){Va(r,mu);var e=Du(r);function r(t,n){var o;return Br(this,r),o=e.call(this),ku.set(za(o),void 0),Su.set(za(o),void 0),ju.set(za(o),void 0),Au.set(za(o),null),t&&!ji(t)&&(n=t,t=[]),tn(za(o),ku,n||{}),tn(za(o),Su,new Na),o.length=0,tn(za(o),ju,Zr(za(o),ku).fieldId||"id"),t&&t.length&&o.add(t),o.setOptions(n),o}return Xr(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?Zr(this,Au)&&(Zr(this,Au).destroy(),tn(this,Au,null)):(Zr(this,Au)||tn(this,Au,gu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===_i(t.queue)&&Zr(this,Au).setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(ji(t)){var i=jr(t).call(t,(function(t){return t[Zr(n,ju)]}));if(Pa(i).call(i,(function(t){return Zr(n,Su).has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==_i(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=Zr(this,ju),c=function(t){var e=t[u];if(null!=e&&Zr(r,Su).has(e)){var c=t,f=Yo({},Zr(r,Su).get(e)),s=r._updateItem(c);o.push(s),a.push(c),i.push(f)}else{var l=r._addItem(t);n.push(l)}};if(ji(t))for(var f=0,s=t.length;f<s;f++)t[f]&&"object"===_i(t[f])?c(t[f]):console.warn("Ignoring input item, which is not an object at index "+f);else{if(!t||"object"!==_i(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return Ri(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;ji(t)||(t=[t]);var o=jr(r=jr(t).call(t,(function(t){var e=Zr(n,Su).get(t[Zr(n,ju)]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[Zr(n,ju)],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return qi.apply(void 0,Ri(e=[{},t]).call(e,n))}(e,r);return Zr(n,Su).set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:jr(o).call(o,(function(t){return t.id})),oldData:jr(o).call(o,(function(t){return t.oldData})),data:jr(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;eu(t)?(r=t,o=e):ji(t)?(n=t,o=e):o=t;var i=o&&"Object"===o.returnType?"Object":"Array",a=o&&Pr(o),u=[],c=void 0,f=void 0,s=void 0;if(null!=r)(c=Zr(this,Su).get(r))&&a&&!a(c)&&(c=void 0);else if(null!=n)for(var l=0,h=n.length;l<h;l++)null==(c=Zr(this,Su).get(n[l]))||a&&!a(c)||u.push(c);else for(var v,p=0,y=(f=Mi(ja(v=Zr(this,Su)).call(v))).length;p<y;p++)s=f[p],null==(c=Zr(this,Su).get(s))||a&&!a(c)||u.push(c);if(o&&o.order&&null==r&&this._sort(u,o.order),o&&o.fields){var d=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,d);else for(var g=0,m=u.length;g<m;g++)u[g]=this._filterFields(u[g],d)}if("Object"==i){for(var b={},w=0,O=u.length;w<O;w++){var x=u[w];b[x[Zr(this,ju)]]=x}return b}return null!=r?null!=c?c:null:u}},{key:"getIds",value:function(t){var e=Zr(this,Su),r=t&&Pr(t),n=t&&t.order,o=Mi(ja(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var f=o[u],s=Zr(this,Su).get(f);null!=s&&r(s)&&a.push(s)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][Zr(this,ju)])}else for(var v=0,p=o.length;v<p;v++){var y=o[v],d=Zr(this,Su).get(y);null!=d&&r(d)&&i.push(d[Zr(this,ju)])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var w=o[m];g.push(e.get(w))}this._sort(g,n);for(var O=0,x=g.length;O<x;O++)i.push(g[O][Zr(this,ju)])}else for(var k=0,S=o.length;k<S;k++){var j=o[k],A=e.get(j);null!=A&&i.push(A[Zr(this,ju)])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Pr(e),n=Zr(this,Su),o=Mi(ja(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[Zr(this,ju)])}else for(var f=0,s=o.length;f<s;f++){var l=o[f],h=Zr(this,Su).get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Pr(e),n=[],o=Zr(this,Su),i=Mi(ja(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],f=Zr(this,Su).get(c);null==f||r&&!r(f)||n.push(t(f,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?zr(r=ji(e)?e:Si(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;Oa(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");Oa(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=ji(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[Zr(this,ju)];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(eu(t)?e=t:t&&"object"===_i(t)&&(e=t[Zr(this,ju)]),null!=e&&Zr(this,Su).has(e)){var r=Zr(this,Su).get(e)||null;return Zr(this,Su).delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Mi(ja(e=Zr(this,Su)).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(Zr(this,Su).get(r[o]));return Zr(this,Su).clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=Tu(va(e=Zr(this,Su)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=Tu(va(e=Zr(this,Su)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=Zr(this,Su),r=Mi(ja(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],f=!1,s=0;s<o;s++)if(n[s]==c){f=!0;break}f||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=tu()),t}(t,Zr(this,ju)),r=e[Zr(this,ju)];if(Zr(this,Su).has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return Zr(this,Su).set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[Zr(this,ju)];if(null==e)throw new Error("Cannot update item: item has no id (item: "+fa(t)+")");var r=Zr(this,Su).get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return Zr(this,Su).set(e,Iu(Iu({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=Zr(this,Su);return new Eu(go({},ra,ea.mark((function r(){var n,o,i,a;return ea.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Tu(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Eu(go({},ra,$r(r=ta(Zr(this,Su))).call(r,Zr(this,Su))))}},{key:"idProp",get:function(){return Zr(this,ju)}}]),r}();function Nu(t,e){var r;if(void 0===Ni||null==oo(t)){if(ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return zu(t,e);var n=Ti(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return lo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=no(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function zu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Gu(t){var e=function(){if("undefined"==typeof Reflect||!Yi)return!1;if(Yi.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Yi(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=$a(t);if(e){var o=$a(this).constructor;r=Yi(n,arguments,o)}else r=n.apply(this,arguments);return Wa(this,r)}}ku=new tr,Su=new tr,ju=new tr,Au=new tr;var Uu=function(t){Va(r,mu);var e=Gu(r);function r(t,n){var o,i;return Br(this,r),(i=e.call(this)).length=0,Lu.set(za(i),void 0),Mu.set(za(i),void 0),Cu.set(za(i),new wu),Fu.set(za(i),void 0),tn(za(i),Fu,n||{}),tn(za(i),Lu,$r(o=i._onEvent).call(o,za(i))),i.setData(t),i}return Xr(r,[{key:"setData",value:function(t){if(Zr(this,Mu)){Zr(this,Mu).off&&Zr(this,Mu).off("*",Zr(this,Lu));var e=Zr(this,Mu).getIds({filter:Pr(Zr(this,Fu))}),r=Zr(this,Mu).get(e);Zr(this,Cu).clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){tn(this,Mu,t);for(var n=Zr(this,Mu).getIds({filter:Pr(Zr(this,Fu))}),o=0,i=n.length;o<i;o++){var a=n[o];Zr(this,Cu).add(a)}this.length=n.length,this._trigger("add",{items:n})}else tn(this,Mu,new Ru);Zr(this,Mu).on&&Zr(this,Mu).on("*",Zr(this,Lu))}},{key:"refresh",value:function(){for(var t=Zr(this,Mu).getIds({filter:Pr(Zr(this,Fu))}),e=Mi(Zr(this,Cu)),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,Zr(this,Cu).has(c)||(n.push(c),Zr(this,Cu).add(c))}for(var f=0,s=e.length;f<s;f++){var l=e[f],h=Zr(this,Mu).get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),Zr(this,Cu).delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==Zr(this,Mu))return null;var r,n=null;eu(t)||ji(t)?(n=t,r=e):r=t;var o=Yo({},Zr(this,Fu),r),i=Pr(Zr(this,Fu)),a=r&&Pr(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?Zr(this,Mu).get(o):Zr(this,Mu).get(n,o)}},{key:"getIds",value:function(t){if(Zr(this,Mu).length){var e,r=Pr(Zr(this,Fu)),n=null!=t?Pr(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,Zr(this,Mu).getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(Zr(this,Mu)){var r,n,o=Pr(Zr(this,Fu)),i=e&&Pr(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,Do(r=Zr(this,Mu)).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(Zr(this,Mu)){var r,n,o=Pr(Zr(this,Fu)),i=e&&Pr(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,jr(r=Zr(this,Mu)).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return Zr(this,Mu).getDataSet()}},{key:"stream",value:function(t){var e;return Zr(this,Mu).stream(t||go({},ra,$r(e=ja(Zr(this,Cu))).call(e,Zr(this,Cu))))}},{key:"dispose",value:function(){var t;(null===(t=Zr(this,Mu))||void 0===t?void 0:t.off)&&Zr(this,Mu).off("*",Zr(this,Lu));var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},i=Nu(Ii(r.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;on(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&Zr(this,Mu)){var n=e.items,o=[],i=[],a=[],u=[],c=[],f=[];switch(t){case"add":for(var s=0,l=n.length;s<l;s++){var h=n[s];this.get(h)&&(Zr(this,Cu).add(h),o.push(h))}break;case"update":for(var v=0,p=n.length;v<p;v++){var y=n[v];this.get(y)?Zr(this,Cu).has(y)?(i.push(y),c.push(e.data[v]),u.push(e.oldData[v])):(Zr(this,Cu).add(y),o.push(y)):Zr(this,Cu).has(y)&&(Zr(this,Cu).delete(y),a.push(y),f.push(e.oldData[v]))}break;case"remove":for(var d=0,g=n.length;d<g;d++){var m=n[d];Zr(this,Cu).has(m)&&(Zr(this,Cu).delete(m),a.push(m),f.push(e.oldData[d]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:f},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}();function qu(t,e){return"object"===_i(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Do(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof jr(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function Vu(t,e){return"object"===_i(e)&&null!==e&&t===e.idProp&&"function"==typeof Do(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof jr(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&qu(t,e.getDataSet())}Lu=new tr,Mu=new tr,Cu=new tr,Fu=new tr;export{Ui as DELETE,Ru as DataSet,Eu as DataStream,Uu as DataView,gu as Queue,en as createNewDataPipeFrom,qu as isDataSetLike,Vu as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
